{% extends 'admin/base.html.twig' %}

{% block title %}Import Excel File{% endblock %}

{% block style %}
    <script src="https://cdn.jsdelivr.net/npm/chart.js"></script>
    <script src="https://code.jquery.com/jquery-3.6.0.min.js" integrity="sha256-/xUj+3OJU5yExlq6GSYGSHk7tPXikynS7ogEvDej/m4=" crossorigin="anonymous"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/html2pdf.js/0.10.1/html2pdf.bundle.min.js" integrity="sha512-GsLlZN/3F2ErC5ifS5QtgpiJtWd43JWSuIgh7mbzZ8zBps+dvLusV+eNQATqgA/HdeKFVgA5v3S/cIrLF7QnIg==" crossorigin="anonymous" referrerpolicy="no-referrer"></script>
{% endblock %}

{% block content %}

    <div class="example-wrapper">
        <div class="row">
            <div class="col">
                <div class="page-description d-flex align-items-center">
                    <div class="page-description-content flex-grow-1">
                        <h1>Graphs</h1>
                    </div>
                </div>
            </div>
        </div>
        <div class="row">
            <table class="table table-responsive">
                <thead>
                <tr>
                    <th class="text-center">Index</th>
                    <th class="text-center">Columns</th>
                </tr>
                </thead>
                <tbody>
                {% for header in fileImport.headers %}
                    <tr>
                        <td class="text-center">{{ loop.index }}</td>
                        <td >{{ header }}</td>
                    </tr>
                {% endfor %}
                </tbody>
            </table>
            <button id="exportPDF" class="btn btn-danger p-20">PDF</button>
        </div>

        <hr/>

        <div>
            <h2>Add a new chart</h2>
            {% for dataset in datasets %}
                <div>
                    {% include 'components/GraphForm.html.twig' with {'fileImport': fileImport, 'dataset': dataset} %}
                </div>
            {% endfor %}
            <div>
                {% include 'components/GraphForm.html.twig' with { 'fileImport': fileImport } %}
            </div>
        </div>
        <div id="charts">
            <div id="entetesPDF" style="display: none">
                {% include 'components/StudyReport.html.twig' %}
            </div>
        </div>


    </div>

    <script defer type="application/javascript">
        const data_content = {{ data_content|json_encode()|raw }};
        const charts_div = $("#charts");
        Object.values(data_content).forEach((value, index) => {
            const test = {
                datasets: [{
                    label: value.data.datasets.label,
                    backgroundColor: 'rgb(255, 99, 132)',
                    borderColor: 'rgb(255, 99, 132)',
                    data: value.data.datasets.data,
                }]
            };

            const config = {
                type: value.type,
                data: test,
                options: {}
            };
            console.log(config)
            let canvas = document.createElement("canvas");
            const chart = new Chart(
                canvas,
                config
            );
            charts_div.append(canvas);
        });

        $(document).ready(function () {
            $("#exportPDF").click(function () {
                //const element = $('#charts');
                const element = document.getElementById("charts");
                const entetesPDF = document.getElementById("entetesPDF");
                const charts = $("#charts > canvas");
                charts.css("width","1000px");
                charts.css("height","700px");
                entetesPDF.style.display = "block";
                let opt = {
                    margin:       1,
                    filename:     'StudyReport-{{ fileImport.id }}.pdf',
                    pagebreak:    { after: 'canvas' },
                    image:        { type: 'jpeg', quality: 1 },
                    html2canvas:  { scale: 1.5 },
                    jsPDF:        { unit: 'cm', format: 'A4', orientation: 'landscape' }
                };
                let worker = html2pdf().set(opt).from(element).save();
                worker.then(() => {
                    entetesPDF.style.display = "none";
                });
            });
        });
    </script>
{% endblock %}
